#!/usr/bin/perl
# indexsoft XML viewer
# http://www.indexsoft.com
########################################
# XML files extensions. commas delimited
$XMLEXT = 'xml';
# working directory
$ROOTDIR = $ENV{'DOCUMENT_ROOT'};
########################################
$VER='1.1';
use CGI;
eval('use XML::Simple');
$XMLERR = $@ if $@;
&ReadParameters();
$P{'dir'}?($DIR = $P{'dir'}):($DIR = $ROOTDIR);
$FILE = $P{'file'};

print &TopOfPage();
if ($FILE)
{
	$XMLERR && print &Error($XMLERR);
	$CONFIG = eval { XMLin($FILE) } || do { print &Error($@); };
	$P{'xmlpath'}?($XMLPATH = $P{'xmlpath'}):($XMLPATH = '');
	#use Data::Dumper; print '<pre>',Dumper($CONFIG),'</pre>'; exit;
	if (!$P{'query'})
	{
		foreach my $line(split('->', $XMLPATH))
		{
			next if !$line;
			$xmlpath .= "->$line";
			$XMLPATHES .= qq{-><a href="xmlview.cgi?dir=$DIR&file=$FILE&xmlpath=$xmlpath">$line</a>}
		}
		$FILE =~ /^(.*)(\\|\/)(.*)$/;
		print &Header(qq{XML Path: <a href="xmlview.cgi?dir=$DIR&file=$FILE">$3</a>$XMLPATHES});
		print '<ul>';
		foreach $section(eval('keys %{$CONFIG'.$XMLPATH.'}'))
		{
			my $ref = ref(eval('$CONFIG'.$XMLPATH."->{$section}"));
			if (!$ref or $ref eq 'HASH')
			{
				print qq{<li><a href="xmlview.cgi?dir=$DIR&file=$FILE&xmlpath=$XMLPATH\->{$section}">$section</a> }
			}
			elsif ($ref eq 'ARRAY')
			{
			  for (my $i=0; $i<=$#{eval('$CONFIG'.$XMLPATH."->{$section}")}; ++$i) { print qq{<li><a href="xmlview.cgi?dir=$DIR&file=$FILE&xmlpath=$XMLPATH\->{$section}\[$i]">$section\[$i]</a>}; }
			}
		}
		print '<li>'.eval('$CONFIG'.$XMLPATH) if !ref(eval('$CONFIG'.$XMLPATH));
		print '</ul>';
	}
	else
	{
		print &Header(qq{Search results:});
		print '<p><ol>';
		&SearchXML($P{'query'}, $XMLPATH);
		print '</ol></p>';
	}
	print &Header(qq{Search through XML ducument});
	print qq{<form action="xmlview.cgi"><input type="hidden" name="file" value="$P{'file'}"><input type="hidden" name="dir" value="$P{'dir'}"><input type="text" name="query" value="$P{'query'}" size="70" style="width:500">&nbsp;<input type="submit" value="Search" style="width:100"></form>};
}
print &Header("Select XML file at $DIR");
print &DirWalker($ROOTDIR, $DIR);
print &BottomOfPage();

########################################################################
sub SearchXML
{
	my ($query, $xmlpath) = @_;
	foreach my $section(eval('keys %{$CONFIG'.$xmlpath.'}'))
	{
		my $ref = ref(eval('$CONFIG'.$xmlpath."->{$section}"));
		if (!$ref or $ref eq 'HASH')
		{
			my $qsection = $section;
			&SearchXML ($query, "$xmlpath\->{$section}");
		}
		elsif ($ref eq 'ARRAY')
		{
		  for (my $i=0; $i<=$#{eval('$CONFIG'.$xmlpath."->{$section}")}; ++$i)
			{
				my $qsection = $section[$i];
				&SearchXML ($query, "$xmlpath\->{$section}\[$i]");
			}
		}
	}
	my $qsection = eval('$CONFIG'.$xmlpath);
	if (!ref(eval('$CONFIG'.$xmlpath)) and $qsection =~ s/($P{'query'})/"<b>$1<\/b>"/gie)
	{
		my ($xmlpath2, $xmlpathes);
		foreach my $line(split('->', $xmlpath))
		{
			next if !$line;
			$xmlpath2 .= "->$line";
			$xmlpathes .= qq{-><a href="xmlview.cgi?dir=$DIR&file=$FILE&xmlpath=$xmlpath2">$line</a>}
		}
		$FILE =~ /^(.*)(\\|\/)(.*)$/;
		print qq{<li><a href="xmlview.cgi?dir=$DIR&file=$FILE">$3</a>$xmlpathes};
		print "<p><ul><li>$qsection</ul></p>";
	}
}

sub TopOfPage
{
	return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n
	<html>
	<head>
	<title>indexsoft XML viewer $VER</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 0px; margin-bottom : 5px; }
		H4 { color : #5588BB; font-size : 16px; }
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; text-align: right;}
		body .small2 { font-size : 11px; text-align: left;}
	</style>
	</head>
	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft XML viewer</h4>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>
	};
}

sub BottomOfPage
{
	return qq{</td></tr></table></td></tr></table><div class=small><a href="mailto:mlist\@indexsoft.com?subject=subscribe4">indexsoft news</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></div></td></tr></table></body></html>};
}

sub Operation
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#C3D5E7"><tr><td valign="top" width="1%"><b>Action:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub Header
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>$_[0]</td></tr></table></td></tr></table><br>};
}

sub Error
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#FFCDCD"><tr><td valign="top" width="1%"><b>Error:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub DirWalker
{
	my ($rootdir, $dir) = @_;
	my ($result, $file, $areaname, @files, @dirs);
	local *DIR;
	if (!$dir or !-d "$dir") { $dir = $rootdir }
	$result .= '<ul>';
	$dir =~ /^(.*)(\\|\/)/;
	$result .= qq{<li><a title="parent directory" href="xmlview.cgi?dir=$1"><b>..</b></a>} if ($rootdir ne $dir);
	opendir (DIR, $dir);
	while ($file = readdir(DIR)) { (-d "$dir/$file") ? push (@dirs, $file) : push (@files, $file) }
	@dirs = sort @dirs;
	@files = sort @files;
	foreach $file(@dirs)	{	$result .= qq{<li><a title="change directory" href="xmlview.cgi?dir=$dir/$file">$file</a>} if ($file ne '.' and $file ne '..') }
	foreach $file(@files)	{	(grep($file =~ /\.$_$/i , split(/\,/, $XMLEXT)))?($result .= qq{<li><a title="view file" href="xmlview.cgi?dir=$dir&file=$dir/$file">$file</a>}):($result .= "<li>$file") }
	closedir(DIR);
	$result .= '</ul>';
	return $result;
}

sub ReadParameters
{
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }
}

